package java.awt;

public class Event {
   private int data;
   public static final int SHIFT_MASK = 1;
   public static final int CTRL_MASK = 2;
   public static final int META_MASK = 4;
   public static final int ALT_MASK = 8;
   public static final int HOME = 1000;
   public static final int END = 1001;
   public static final int PGUP = 1002;
   public static final int PGDN = 1003;
   // $FF: renamed from: UP int
   public static final int field_0 = 1004;
   public static final int DOWN = 1005;
   public static final int LEFT = 1006;
   public static final int RIGHT = 1007;
   // $FF: renamed from: F1 int
   public static final int field_1 = 1008;
   // $FF: renamed from: F2 int
   public static final int field_2 = 1009;
   // $FF: renamed from: F3 int
   public static final int field_3 = 1010;
   // $FF: renamed from: F4 int
   public static final int field_4 = 1011;
   // $FF: renamed from: F5 int
   public static final int field_5 = 1012;
   // $FF: renamed from: F6 int
   public static final int field_6 = 1013;
   // $FF: renamed from: F7 int
   public static final int field_7 = 1014;
   // $FF: renamed from: F8 int
   public static final int field_8 = 1015;
   // $FF: renamed from: F9 int
   public static final int field_9 = 1016;
   public static final int F10 = 1017;
   public static final int F11 = 1018;
   public static final int F12 = 1019;
   private static final int WINDOW_EVENT = 200;
   public static final int WINDOW_DESTROY = 201;
   public static final int WINDOW_EXPOSE = 202;
   public static final int WINDOW_ICONIFY = 203;
   public static final int WINDOW_DEICONIFY = 204;
   public static final int WINDOW_MOVED = 205;
   private static final int KEY_EVENT = 400;
   public static final int KEY_PRESS = 401;
   public static final int KEY_RELEASE = 402;
   public static final int KEY_ACTION = 403;
   public static final int KEY_ACTION_RELEASE = 404;
   private static final int MOUSE_EVENT = 500;
   public static final int MOUSE_DOWN = 501;
   public static final int MOUSE_UP = 502;
   public static final int MOUSE_MOVE = 503;
   public static final int MOUSE_ENTER = 504;
   public static final int MOUSE_EXIT = 505;
   public static final int MOUSE_DRAG = 506;
   private static final int SCROLL_EVENT = 600;
   public static final int SCROLL_LINE_UP = 601;
   public static final int SCROLL_LINE_DOWN = 602;
   public static final int SCROLL_PAGE_UP = 603;
   public static final int SCROLL_PAGE_DOWN = 604;
   public static final int SCROLL_ABSOLUTE = 605;
   private static final int LIST_EVENT = 700;
   public static final int LIST_SELECT = 701;
   public static final int LIST_DESELECT = 702;
   private static final int MISC_EVENT = 1000;
   public static final int ACTION_EVENT = 1001;
   public static final int LOAD_FILE = 1002;
   public static final int SAVE_FILE = 1003;
   public static final int GOT_FOCUS = 1004;
   public static final int LOST_FOCUS = 1005;
   public Object target;
   public long when;
   // $FF: renamed from: id int
   public int field_10;
   // $FF: renamed from: x int
   public int field_11;
   // $FF: renamed from: y int
   public int field_12;
   public int key;
   public int modifiers;
   public int clickCount;
   public Object arg;
   public Event evt;

   public Event(Object target, long when, int id, int x, int y, int key, int modifiers, Object arg) {
      this.target = target;
      this.when = when;
      this.field_10 = id;
      this.field_11 = x;
      this.field_12 = y;
      this.key = key;
      this.modifiers = modifiers;
      this.arg = arg;
      this.data = 0;
      this.clickCount = 0;
   }

   public Event(Object target, long when, int id, int x, int y, int key, int modifiers) {
      this(target, when, id, x, y, key, modifiers, (Object)null);
   }

   public Event(Object target, int id, Object arg) {
      this(target, 0L, id, 0, 0, 0, 0, arg);
   }

   public void translate(int x, int y) {
      this.field_11 += x;
      this.field_12 += y;
   }

   public boolean shiftDown() {
      return (this.modifiers & 1) != 0;
   }

   public boolean controlDown() {
      return (this.modifiers & 2) != 0;
   }

   public boolean metaDown() {
      return (this.modifiers & 4) != 0;
   }

   protected String paramString() {
      String str = "id=" + this.field_10 + ",x=" + this.field_11 + ",y=" + this.field_12;
      if (this.key != 0) {
         str = str + ",key=" + this.key;
      }

      if (this.shiftDown()) {
         str = str + ",shift";
      }

      if (this.controlDown()) {
         str = str + ",control";
      }

      if (this.metaDown()) {
         str = str + ",meta";
      }

      if (this.target != null) {
         str = str + ",target=" + this.target;
      }

      if (this.arg != null) {
         str = str + ",arg=" + this.arg;
      }

      return str;
   }

   public String toString() {
      return this.getClass().getName() + "[" + this.paramString() + "]";
   }
}
