package java.awt;

public class GridBagConstraints implements Cloneable {
   public static final int RELATIVE = -1;
   public static final int REMAINDER = 0;
   public static final int NONE = 0;
   public static final int BOTH = 1;
   public static final int HORIZONTAL = 2;
   public static final int VERTICAL = 3;
   public static final int CENTER = 10;
   public static final int NORTH = 11;
   public static final int NORTHEAST = 12;
   public static final int EAST = 13;
   public static final int SOUTHEAST = 14;
   public static final int SOUTH = 15;
   public static final int SOUTHWEST = 16;
   public static final int WEST = 17;
   public static final int NORTHWEST = 18;
   public int gridx = -1;
   public int gridy = -1;
   public int gridwidth = 1;
   public int gridheight = 1;
   public double weightx = (double)0.0F;
   public double weighty = (double)0.0F;
   public int anchor = 10;
   public int fill = 0;
   public Insets insets = new Insets(0, 0, 0, 0);
   public int ipadx = 0;
   public int ipady = 0;
   int tempX;
   int tempY;
   int tempWidth;
   int tempHeight;
   int minWidth;
   int minHeight;

   public Object clone() {
      try {
         GridBagConstraints c = (GridBagConstraints)super.clone();
         c.insets = (Insets)this.insets.clone();
         return c;
      } catch (CloneNotSupportedException var2) {
         throw new InternalError();
      }
   }
}
