package java.awt;

abstract class MediaEntry {
   MediaTracker tracker;
   // $FF: renamed from: ID int
   int field_0;
   MediaEntry next;
   int status;
   static final int LOADING = 1;
   static final int ABORTED = 2;
   static final int ERRORED = 4;
   static final int COMPLETE = 8;
   static final int LOADSTARTED = 13;
   static final int DONE = 14;

   MediaEntry(MediaTracker mt, int id) {
      this.tracker = mt;
      this.field_0 = id;
   }

   abstract Object getMedia();

   static MediaEntry insert(MediaEntry head, MediaEntry me) {
      MediaEntry cur = head;

      MediaEntry prev;
      for(prev = null; cur != null && cur.field_0 <= me.field_0; cur = cur.next) {
         prev = cur;
      }

      me.next = cur;
      if (prev == null) {
         head = me;
      } else {
         prev.next = me;
      }

      return head;
   }

   int getID() {
      return this.field_0;
   }

   abstract void startLoad();

   synchronized int getStatus(boolean doLoad) {
      if (doLoad && (this.status & 13) == 0) {
         this.status = this.status & -3 | 1;
         this.startLoad();
      }

      return this.status;
   }

   void setStatus(int flag) {
      synchronized(this){}

      try {
         this.status = flag;
      } catch (Throwable var4) {
         throw var4;
      }

      this.tracker.setDone();
   }
}
