package java.awt.image;

public abstract class ColorModel {
   protected int pixel_bits;
   private static ColorModel RGBdefault;

   public static ColorModel getRGBdefault() {
      if (RGBdefault == null) {
         RGBdefault = new DirectColorModel(32, 16711680, 65280, 255, -16777216);
      }

      return RGBdefault;
   }

   public ColorModel(int bits) {
      this.pixel_bits = bits;
   }

   public int getPixelSize() {
      return this.pixel_bits;
   }

   public abstract int getRed(int var1);

   public abstract int getGreen(int var1);

   public abstract int getBlue(int var1);

   public abstract int getAlpha(int var1);

   public int getRGB(int pixel) {
      return this.getAlpha(pixel) << 24 | this.getRed(pixel) << 16 | this.getGreen(pixel) << 8 | this.getBlue(pixel);
   }
}
