package java.awt;

import java.awt.peer.CheckboxMenuItemPeer;

public class CheckboxMenuItem extends MenuItem {
   boolean state = false;

   public CheckboxMenuItem(String label) {
      super(label);
   }

   public synchronized void addNotify() {
      super.peer = Toolkit.getDefaultToolkit().createCheckboxMenuItem(this);
      super.addNotify();
   }

   public boolean getState() {
      return this.state;
   }

   public void setState(boolean t) {
      this.state = t;
      CheckboxMenuItemPeer peer = (CheckboxMenuItemPeer)super.peer;
      if (peer != null) {
         peer.setState(t);
      }

   }

   public String paramString() {
      return super.paramString() + ",state=" + this.state;
   }
}
