package java.awt;

import java.awt.peer.ChoicePeer;
import java.util.Vector;

public class Choice extends Component {
   Vector pItems = new Vector();
   int selectedIndex = -1;

   public synchronized void addNotify() {
      super.peer = ((Component)this).getToolkit().createChoice(this);
      super.addNotify();
   }

   public int countItems() {
      return this.pItems.size();
   }

   public String getItem(int index) {
      return (String)this.pItems.elementAt(index);
   }

   public synchronized void addItem(String item) {
      if (item == null) {
         throw new NullPointerException();
      } else {
         this.pItems.addElement(item);
         ChoicePeer peer = (ChoicePeer)super.peer;
         if (peer != null) {
            peer.addItem(item, this.pItems.size() - 1);
         }

         if (this.selectedIndex < 0) {
            this.select(0);
         }

      }
   }

   public String getSelectedItem() {
      int selectedIndex = this.selectedIndex;
      return selectedIndex >= 0 ? this.getItem(selectedIndex) : null;
   }

   public int getSelectedIndex() {
      return this.selectedIndex;
   }

   public synchronized void select(int pos) {
      if (pos >= this.pItems.size()) {
         throw new IllegalArgumentException("illegal Choice item position: " + pos);
      } else {
         if (this.pItems.size() > 0) {
            this.selectedIndex = pos;
            ChoicePeer peer = (ChoicePeer)super.peer;
            if (peer != null) {
               peer.select(pos);
            }
         }

      }
   }

   public void select(String str) {
      int index = this.pItems.indexOf(str);
      if (index >= 0) {
         this.select(index);
      }

   }

   protected String paramString() {
      return super.paramString() + ",current=" + this.getSelectedItem();
   }
}
