package java.awt;

import java.awt.peer.FileDialogPeer;
import java.io.FilenameFilter;

public class FileDialog extends Dialog {
   public static final int LOAD = 0;
   public static final int SAVE = 1;
   int mode;
   String dir;
   String file;
   FilenameFilter filter;

   public FileDialog(Frame parent, String title) {
      this(parent, title, 0);
   }

   public FileDialog(Frame parent, String title, int mode) {
      super(parent, title, true);
      this.mode = mode;
      ((Container)this).setLayout((LayoutManager)null);
   }

   public synchronized void addNotify() {
      super.peer = ((Window)this).getToolkit().createFileDialog(this);
      if (super.peer != null) {
         super.addNotify();
      }

   }

   public int getMode() {
      return this.mode;
   }

   public String getDirectory() {
      return this.dir;
   }

   public void setDirectory(String dir) {
      this.dir = dir;
      if (super.peer != null) {
         ((FileDialogPeer)super.peer).setDirectory(dir);
      }

   }

   public String getFile() {
      return this.file;
   }

   public void setFile(String file) {
      this.file = file;
      if (super.peer != null) {
         ((FileDialogPeer)super.peer).setFile(file);
      }

   }

   public FilenameFilter getFilenameFilter() {
      return this.filter;
   }

   public void setFilenameFilter(FilenameFilter filter) {
      this.filter = filter;
      FileDialogPeer peer = (FileDialogPeer)super.peer;
      if (peer != null) {
         peer.setFilenameFilter(filter);
      }

   }

   protected String paramString() {
      String str = super.paramString();
      if (this.dir != null) {
         str = str + ",dir= " + this.dir;
      }

      return str + (this.mode == 0 ? ",load" : ",save");
   }
}
