package java.awt;

import java.awt.peer.MenuComponentPeer;

public abstract class MenuComponent {
   MenuComponentPeer peer;
   MenuContainer parent;
   Font font;

   public MenuContainer getParent() {
      return this.parent;
   }

   public MenuComponentPeer getPeer() {
      return this.peer;
   }

   public Font getFont() {
      Font font = this.font;
      if (font != null) {
         return font;
      } else {
         MenuContainer parent = this.parent;
         return parent != null ? parent.getFont() : null;
      }
   }

   public void setFont(Font f) {
      this.font = f;
   }

   public void removeNotify() {
      MenuComponentPeer p = this.peer;
      if (p != null) {
         p.dispose();
         this.peer = null;
      }

   }

   public boolean postEvent(Event evt) {
      MenuContainer parent = this.parent;
      if (parent != null) {
         parent.postEvent(evt);
      }

      return false;
   }

   protected String paramString() {
      return "";
   }

   public String toString() {
      return this.getClass().getName() + "[" + this.paramString() + "]";
   }
}
