package java.awt;

import java.awt.peer.MenuItemPeer;

public class MenuItem extends MenuComponent {
   boolean enabled = true;
   String label;

   public MenuItem(String label) {
      this.label = label;
   }

   public synchronized void addNotify() {
      if (super.peer == null) {
         super.peer = Toolkit.getDefaultToolkit().createMenuItem(this);
      }

   }

   public String getLabel() {
      return this.label;
   }

   public void setLabel(String label) {
      this.label = label;
      MenuItemPeer peer = (MenuItemPeer)super.peer;
      if (peer != null) {
         peer.setLabel(label);
      }

   }

   public boolean isEnabled() {
      return this.enabled;
   }

   public void enable() {
      this.enabled = true;
      MenuItemPeer peer = (MenuItemPeer)super.peer;
      if (peer != null) {
         peer.enable();
      }

   }

   public void enable(boolean cond) {
      if (cond) {
         this.enable();
      } else {
         this.disable();
      }
   }

   public void disable() {
      this.enabled = false;
      MenuItemPeer peer = (MenuItemPeer)super.peer;
      if (peer != null) {
         peer.disable();
      }

   }

   public String paramString() {
      return "label=" + this.label;
   }
}
